#ifndef TESTCOMM_SPIPORT_H
#define TESTCOMM_SPIPORT_H
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <string>
#include <thread>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <linux/types.h>
#include <linux/spi/spidev.h>

#include <android/log.h>

using namespace std;

typedef unsigned char u8;

class SpiPort {
public:

    SpiPort();
    virtual ~SpiPort();

    bool Open(const char* path);
    void Close();

    int spi_transfer(unsigned char *txbuf, unsigned char *rxbuf, int bytes);
    void spi_master_init();
    static int delay(int x);

protected:
    std::string m_path;
    int m_fd;

};




#endif //TESTCOMM_SPIPORT_H
