#include <jni.h>
#include <string>

#include "NrsecPort.h"
#include "GPIOControl.h"

#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <linux/spi/spidev.h>
#include <android/log.h>


extern "C" JNIEXPORT jstring JNICALL
Java_com_xinyingpower_testcomm_MainActivity_stringFromJNI(
        JNIEnv* env,
        jobject /* this */) {
    std::string hello = "Hello from C++";
    return env->NewStringUTF(hello.c_str());
}

extern "C" JNIEXPORT jstring JNICALL
Java_com_xinyingpower_testcomm_MainActivity_testSpi(
        JNIEnv* env,
        jobject /* this */, jint port) {
    //testSpi();
    GpioControl::setInt(23, 1);

    const char* path = "/dev/spidevSE"; // DOWSE

    NrsecPort a;
    a.Open(path);

    unsigned char newkey[32]={0xaf,0x0c,0xa9,0x40,0x1f,0xe6,0xee,0x0f,0x4c,
                                     0xfb,0xf7,0x17,0x71,0xde,0x61,0x59
                                     ,0x0a,0x05,0x77,
                                     0xfa,0xe7,0xd1,0x8d,0x10,0x3a,0x79,0x23,0xf2,0xb3,
                                     0x6d,0xea,0x8e
//                                     ,0xe0,0x64,0xe7,0x5d,0x49,0x84,0xe4,
//                                     0x5f,0xc9,0x07,0x03,0x52,0x33,0x79,0x87,0xd4,0x62,
//                                     0x62,0xc0,0xcc,0xf0,0xd6,0x85,0x20,0x7f,0x7a,0xe8,
//                                     0xc8,0xed,0x12,0xdb,0xdc
    };
    unsigned char outpub[32],outsign[64], *outen = new unsigned char [256];
    unsigned char pucid[16]={0x01,0x01,0x01,0x01,0x01,0x01,0x01,
                             0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01};
    string b="C=CN,ST=jiangsu,L=nanjing,O=GDD,OU=nari,CN=test001";
    a.Version();

    uint8_t output[16] = { 0 };
    a.Random(output, 16);

    a.SM2keypair(0x00);
    //a.SM3Hash(newkey,16, outpub);
    //a.sm3hash_tosm2(newkey,16,outpub,newkey,pucid,16);
    //a.SM2Sign(0x00,outpub,outsign);
    //a.SM2VerifySign(0x00,outpub,outsign);
    // a.SM2cert(0x00,0x00,b,outen);
    for (int i = 0; i < 32; i++) {
        //sprintf(output, " %02x ", rxbuf[i]);
        __android_log_print(ANDROID_LOG_INFO, "SPi", "%02x", outen[i]);
    }
//    a.SM2decoder(0x00,outen,outpub);
//
//    for (int i = 0; i < 64; i++) {
//        //sprintf(output, " %02x ", rxbuf[i]);
//        __android_log_print(ANDROID_LOG_INFO, "SPi", "%02x", outpub[i]);
//    }

    //a.SM3Hash(0x00,0x10,newkey);
    //testVersion();

    return env->NewStringUTF("End");

}